{ VGA256 V2.1                                                                }
{ For english comments see SVGA256.PAS                                       }
{ Unit pre pracu s 256-farebnou grafikou na karte VGA                        }
{ Potrebuje nasledovne subory:                                               }
{  VGA256.BGI   -  Borland Graphics Interface pre VGA mod 320x200x256        }
{ (c) Matus Horvath, 1997                                                    }
unit VGA256;
{-[ INTERFACE ]----------------------------------------------------/////-----}
 interface
{-----[ Typ DacPalette256 pre pracu s paletou ]--------------------/////-----}
  type DacPalette256 = array[0..255] of array[0..2] of Byte;

{-----[ Konstanty pre inicializaciu grafiky ]----------------------/////-----}
  const VGA320x200x256   = 0;   {  320x200x256 }
        V32256           = 0;
{-----[ Konstanty pre cesty k suborom BGI a CHR ]------------------/////-----}
        Bgi    = 'C:\TP\BGI\';  { Adresar BGI  }
        TP     = 'C:\TP\';      { Adresar TP   }
{-----[ Premenne ]-------------------------------------------------/////-----}
  var VGA32256:integer;         { Cislo drivera pre InitGraph           }

{-----[ Inicializacia ]--------------------------------------------/////-----}
{-------[ Procedura INITIALIZE kompatibilna so SVGA256 1.x ]-------/////-----}
  procedure Initialize(gm:integer;pd:string);
{-------[ Procedura pre rychlu inicializaciu ]---------------------/////-----}
  procedure I32256;    {  320x200x256 }
{-------[ Nastavenie palety ]--------------------------------------/////-----}
  procedure SetVGAPalette(PalBuf : DacPalette256);
{-[ IMPLEMENTATION ]-----------------------------------------------/////-----}
 implementation
  uses Crt, Dos, Graph;

{-----[ Procedura, ktora detekuje VGA/MCGA/VESA + optimalny mod ]--/////-----}
  {$F+}
  function DetectVGA256: integer;
  {-----[ Parametre ]-------------------------/////-----}
  { Ziadne                                              }
  {-----[ Vystup ]----------------------------/////-----}
  { Cislo optimalneho modu alebo grError ak nie je      }
  { pritomna VGA/MCGA kompatibilna graficka karta.      }
   var gd,gm:integer;
   begin
    detectgraph(gd,gm);
    if (gd=VGA)or(gd=MCGA) then detectvga256:=VGA320x200x256
                           else detectvga256:=grError;
   end; { DetectVGA256 }
   {$F-}

{-----[ Inicializacia gr. modu kompatibilna so SVGA256 1.x ]-------/////-----}
  procedure Initialize(gm:integer;pd:string);
  {-----[ Parametre ]-------------------------/////-----}
  { GM = Cislo modu                                     }
  { PD = Cesta k suboru VGA256.BGI                      }
   var PathToDriver:string;
       ErrorCode:integer;
   begin
    DirectVideo:=False;
    PathToDriver:=PD;
    repeat
     InitGraph(VGA32256,GM,PathToDriver);
     ErrorCode:=GraphResult;
     if ErrorCode<>grOK then begin
      Writeln('Graphics error: ', GraphErrorMsg(ErrorCode));
      if ErrorCode=grFileNotFound then begin
       Writeln('Enter full path to BGI driver or type <Ctrl-Break> to quit:');
       Readln(PathToDriver);
       Writeln;
      end else Halt(1);
     end;
    until ErrorCode=grOK;
    setcolor(white);
   end; { Initialize }

{-----[ Nastavenie palety ]----------------------------------------/////-----}
  procedure SetVGAPalette(PalBuf:DacPalette256);
  {-----[ Parametre ]-------------------------/////-----}
  { PalBuf = Nova paleta                                }
   var Reg:Registers;
   begin
    reg.ax := $1012;
    reg.bx := 0;
    reg.cx := 256;
    reg.es := Seg(PalBuf);
    reg.dx := Ofs(PalBuf);
    intr($10,reg);
   end;

{-----[ Rychla inicializacia gr. modov ]---------------------------/////-----}
  procedure I32256;
   begin
    initialize(0,bgi);
   end;

  begin
  VGA32256:=InstallUserDriver('SVGA256', @DetectVGA256);
  if VGA32256=grError then VGA32256:=Detect;
 end.
